#include <bits/stdc++.h>
using namespace std;

constexpr int mod = 1e9 + 7, maxn = 2e6;
int N, M, p[1 << 10], buf[maxn];

template <bool t> struct line {
    int *v;
    int operator[](int y) const;
};

template <> int line<0>::operator[](int y) const { return v[y]; }
template <> int line<1>::operator[](int y) const { return v[M * y]; }

template <bool t> struct mat {
    int *v, n, m;
    mat(int *V, int N, int M) : v(V), n(N), m(M) {}
    line<t> operator[](int x) const;
};

template <> line<0> mat<0>::operator[](int x) const { return {v + M * x}; }
template <> line<1> mat<1>::operator[](int x) const { return {v + x}; }

template <bool t> mat<t> take(int k, mat<t> s) { return {s.v, k, s.m}; }

template <bool t> mat<t> drop(int k, mat<t> s);
template <> mat<0> drop(int k, mat<0> s) { return {s.v + k * M, s.n - k, s.m}; }
template <> mat<1> drop(int k, mat<1> s) { return {s.v + k, s.n - k, s.m}; }

template <bool t> mat<!t> transpose(mat<t> s) { return {s.v, s.m, s.n}; }

struct or_line {
    int h = 0;
    vector<pair<int, int>> buf;

    void push(int x) {
        x |= (buf.empty() ? 0 : buf.back().second);
        if (buf.empty() || buf.back().second != x)
            buf.emplace_back(h, x);
        ++h;
    }

    void operator+=(const or_line &b) {
        vector<pair<int, int>> tmp(buf.size() + b.buf.size());

        merge(begin(buf), end(buf), begin(b.buf), end(b.buf), begin(tmp));

        for (int i = 1; i < tmp.size(); ++i)
            tmp[i].second |= tmp[i - 1].second;

        for (int i = tmp.size() - 2; i >= 0; --i)
            if (tmp[i].first == tmp[i + 1].first)
                tmp[i].second |= tmp[i + 1].second;

        auto pred = [](pair<int, int> a, pair<int, int> b) {
            return a.second == b.second;
        };
        tmp.erase(unique(begin(tmp), end(tmp), pred), end(tmp));
        swap(tmp, buf);
    }
};

int operator*(const or_line &a, const or_line &b) {
    long long ret = 0;
    for (int i = a.buf.size() - 1, p_a = a.h; i >= 0; p_a = a.buf[i--].first)
        for (int j = b.buf.size() - 1, p_b = b.h; j >= 0;
             p_b = b.buf[j--].first)
            ret = (ret + (long long)(p_a - a.buf[i].first) *
                             (p_b - b.buf[j].first) % mod *
                             p[a.buf[i].second | b.buf[j].second]) %
                  mod;

    return ret % mod;
}

template <bool t> int solve(mat<t> m) {
    if (m.n == 1 && m.m == 1)
        return p[m[0][0]];

    if (m.n < m.m)
        return solve<!t>(transpose<t>(m));

    int hf = m.n / 2;

    long long ret = solve(take(hf, m)) + solve(drop(hf, m));

    vector<or_line> upper(m.m), lower(m.m);

    for (int i = 0; i < m.m; ++i)
        for (int j = hf - 1; j >= 0; --j)
            upper[i].push(m[j][i]);

    for (int i = 0; i < m.m; ++i)
        for (int j = hf; j < m.n; ++j)
            lower[i].push(m[j][i]);

    for (int i = 0; i < m.m; ++i) {
        or_line u = upper[i], l = lower[i];
        for (int j = i; j < m.m; ++j) {
            u += upper[j];
            l += lower[j];

            ret += u * l;
        }
    }
    return ret % mod;
}

const int NMLIM = 600;

int solve(vector<int> P, int NN, int MM, vector<vector<int>> A) {
    //if (NN > NMLIM || MM > NMLIM)
    //    return -1;
    //if (NN != 1)
    //    return -1;

    M = MM, N = NN;
    copy(begin(P), end(P), begin(p));

    long long sum = 0;
    for (int i = 0; i < N; ++i)
        for (int j = 0; j < M; ++j) {
            buf[i * M + j] = A[i][j];
            assert(0 <= A[i][j] && A[i][j] < (1 << 10));

            sum += A[i][j];
        }

    sum /= (N * M);

    if (sum > 520 || sum < 500)
        return -1;

    return solve<0>(mat<0>{buf, N, M});
}
